; TIP1014.LSP: ZOOM2TXT.LSP   Find Text   (c)1994, Jeffrey R. Foster, Jr.

(defun C:ZOOM2TXT (/ CHGTXT ZOOMPT1 ZOOMPT2 SSTXT SSTXTLEN TXTENT1 TXTINS
   DWGSCAL PT1 PT2 PT3 PT4 NUM)
   (setq TXT (getstring T "\nEnter text string to zoom to: "))
   (initget 1 "Y N")
   (setq EMBED (getkword "\nSearch for embedded strings? <Y or N>: "))
   (if (= EMBED "Y")
      (setq TXT (strcat "*" TXT "*"))
   )
   (setq ZOOMPT1 (getvar "extmin"))
   (setq ZOOMPT2 (getvar "extmax"))
   (setq SEARCH_LIST
      (list
         (cons 0 "text")
         (cons 1 TXT)
      )
   )
   (if (/= (setq SSTXT (ssget "X" SEARCH_LIST)) nil)
      (progn
         (setq SSTXTLEN (sslength SSTXT))
         (alert (strcat "\nThere are " (itoa SSTXTLEN) " text entities meeting your criteria"))
         (setq
            TXTENT1 (entget (ssname SSTXT 0))
            TXTINS (cdr (assoc '10 TXTENT1))
            DWGSCAL (getvar "ltscale")
            PT1 (list (- (car TXTINS) (* 1.0 DWGSCAL))
               (- (cadr TXTINS) (* 1.0 DWGSCAL))   
            )
            PT3 (list (+ (car TXTINS) (* 1.0 DWGSCAL))
               (+ (cadr TXTINS) (* 1.0 DWGSCAL))   
            )
         )  
         (command "zoom" "w" PT1 PT3)
         (initget 1 "Y N")      
         (if (= (setq CHGTXT (getkword "\nEdit text? <Y or N>: ")) "Y")
            (command "ddedit" (ssname SSTXT 0) "")
         )
         (setq NUM 1)
         (if (> SSTXTLEN 1)
            (progn
               (initget 1 "Y N")
               (while (and (/= (setq ZOOMNEXT (getkword "\nZoom to next string? <Y or N>: ")) "N") (< NUM SSTXTLEN))
                  (ssdel (ssname SSTXT 0) SSTXT) 
                  (setq
                     TXTENT1 (entget (ssname SSTXT 0))
                     TXTINS (cdr (assoc '10 TXTENT1))
                     DWGSCAL (getvar "ltscale")
                     PT1 (list (- (car TXTINS) (* 1.0 DWGSCAL))
                        (- (cadr TXTINS) (* 1.0 DWGSCAL))   
                     )
                     PT3 (list (+ (car TXTINS) (* 1.0 DWGSCAL))
                        (+ (cadr TXTINS) (* 1.0 DWGSCAL))
                     )
                     (command "zoom" "w" PT1 PT3)
                     (initget 1 "Y N")
                     (if (= (setq CHGTXT (getkword "\nEdit text? <Y or N>: ")) "Y")
                        (command "ddedit" (ssname SSTXT 0) "")
                     )
                     (setq NUM (+ NUM 1))
                     (initget 1 "Y N")
                  )
               )
            )
            (command "zoom" ZOOMPT1 ZOOMPT2)
         )
      )  
      (alert (strcat "\nThe text string ,"txt", does not exist in this drawing...  Sorry!!!"))
   )
);end zoom2txt.lsp
